#ifndef _LINUXINPUTEVENT_H
#define _LINUXINPUTEVENT_H

#include <QObject>
#include <QString>
#include <QSocketNotifier>
#include <linux/input.h>

class LinuxInputEvent : public QObject
{
	Q_OBJECT
  public:
	LinuxInputEvent(const QString &dev, QObject *parent = 0);
	virtual ~LinuxInputEvent();
	virtual bool grab(bool enable = true);
	virtual void ignore(bool ignore = true);
	virtual void waitForRelease() {};
	bool isBuffered();

  protected:
	virtual void recvEvent(struct input_event *ev) = 0;
	bool m_ignore;

  protected slots:
	void readEvent();
	void quit();

  protected:
	QSocketNotifier *m_notify;
	int m_fd;

  signals:
	void triggered();
};

#endif // _LINUXINPUTEVENT_H
